module demux
(
input               Addr_or_Data,
input               Write,
input               SRAM_TO_MCU_DATA,
input [3:0]	        SEL_Addr,
input [7:0]         DATA_IN,
input [7:0]         IN_KEY,

output reg [15:0]   Addr_Decode_OUT,
output reg [3:0]    SEL_Addr_OUT = 0,


output reg [7:0]    REG_DATA_OUT,

output reg [15:0]   Decimation,
output reg [7:0]    Trigger_level_A,
output reg [7:0]    Trigger_level_B,
output reg [17:0]   WIN_DATA,
output reg [7:0]    cnfPin
);


always @(posedge Write) begin
	
  if(Addr_or_Data == 1) begin
    
        SEL_Addr_OUT <= SEL_Addr;

	    case (SEL_Addr)
		4'b0000:     Addr_Decode_OUT <= 16'b0000000000000000;
		4'b0001:	 Addr_Decode_OUT <= 16'b0000000000000001;
		4'b0010:	 Addr_Decode_OUT <= 16'b0000000000000010;
		4'b0011:	 Addr_Decode_OUT <= 16'b0000000000000100;
		4'b0100:	 Addr_Decode_OUT <= 16'b0000000000001000;
		4'b0101:	 Addr_Decode_OUT <= 16'b0000000000010000;
		4'b0110:	 Addr_Decode_OUT <= 16'b0000000000100000;
		4'b0111:	 Addr_Decode_OUT <= 16'b0000000001000000;
		4'b1000:	 Addr_Decode_OUT <= 16'b0000000010000000;
		4'b1001:	 Addr_Decode_OUT <= 16'b0000000100000000;
		4'b1010:	 Addr_Decode_OUT <= 16'b0000001000000000;
		4'b1011:	 Addr_Decode_OUT <= 16'b0000010000000000;
		4'b1100:	 Addr_Decode_OUT <= 16'b0000100000000000;
		4'b1101:	 Addr_Decode_OUT <= 16'b0001000000000000;
		4'b1110:	 Addr_Decode_OUT <= 16'b0010000000000000;
		4'b1111:	 Addr_Decode_OUT <= 16'b0100000000000000;
		default:     Addr_Decode_OUT <= 0;
	    endcase
  end
  else if(Addr_or_Data == 0) begin
       case (Addr_Decode_OUT)
	   16'b0000000000000000:	 Decimation[7:0]  <=  DATA_IN;
	   16'b0000000000000001:	 Decimation[15:8] <=  DATA_IN;
	   16'b0000000000000010:	 Trigger_level_A  <=  DATA_IN;
	   16'b0000000000000100:	 Trigger_level_B  <=  DATA_IN;
	   16'b0000000000001000:	 WIN_DATA[7:0]    <=  DATA_IN;
	   16'b0000000000010000:	 WIN_DATA[15:8]   <=  DATA_IN;
	   16'b0000000000100000:	 cnfPin           <=  DATA_IN;
	   default;		 
	   endcase
  end	
end  //always


always @* begin	//

  case (SEL_Addr_OUT)
		4'b0000:     REG_DATA_OUT = Decimation[7:0];
		4'b0001:	 REG_DATA_OUT = Decimation[15:8];
		4'b0010:	 REG_DATA_OUT = Trigger_level_A;
		4'b0011:	 REG_DATA_OUT = Trigger_level_B;
		4'b0100:	 REG_DATA_OUT = WIN_DATA[7:0];
		4'b0101:	 REG_DATA_OUT = WIN_DATA[15:8];
		4'b0110:	 REG_DATA_OUT = cnfPin;
		4'b0111:	 REG_DATA_OUT = IN_KEY;
		4'b1000:	 REG_DATA_OUT = 8'b00000000;
		4'b1001:	 REG_DATA_OUT = 8'b00000000;
		4'b1010:	 REG_DATA_OUT = 8'b00000000;
		4'b1011:	 REG_DATA_OUT = 8'b00000000;
		4'b1100:	 REG_DATA_OUT = 8'b00000000;
		4'b1101:	 REG_DATA_OUT = 8'b10101110;
		4'b1110:	 REG_DATA_OUT = 8'b00000000;
		4'b1111:	 REG_DATA_OUT = SRAM_TO_MCU_DATA;
		default:     REG_DATA_OUT = 0;
  endcase
end	//always

endmodule