
module trig_with_delay
(
input [7:0]  Trg_Lv_UP,
input [7:0]  Trg_Lv_DOWN,
input [7:0]  DATA_IN_A,
input [7:0]  DATA_IN_B,
input [7:0]  Delay,          //    
input sync_sourse,           // 0/1 -     
input Sync_OUT_WIN,          //   /  ,   Trg_Lv_UP  Trg_Lv_DOWN
input Start_Write,           //  
input CLK_EN,                //  
input Enable_Trig,           //  ,    /
input CLK,
    
output reg         first_event_reg,     //     
output reg         last_event_reg,      //   
output             sync_state_out,      //   
output reg [7:0]   SlCounter = Delay,   // 

output             trig_out             //  
);




//   ,    sync_sourse, 0/1 -     
wire [7:0] DATA_SYNC = (sync_sourse == 0)? DATA_IN_A : DATA_IN_B;

//  
wire sync_state = (Trg_Lv_UP > DATA_IN_A) & (Trg_Lv_DOWN < DATA_IN_A)? Sync_OUT_WIN ^ 1 : Sync_OUT_WIN ^ 0;

assign     sync_state_out = sync_state;          //  
assign     trig_out = last_event_reg;            //  
assign     EN_Trig = Start_Write & Enable_Trig;  //  


always @(posedge CLK)
begin
     if(EN_Trig == 0) begin //  
     
         first_event_reg <= 0;
         last_event_reg <= 0;
         SlCounter <= Delay;
         
     end
     else begin //  
         
         if(first_event_reg == 0) begin    //  .        .  -  .
         
             //    
             if(sync_state == 0) begin
                 //  
                 if(SlCounter == 0) begin
                     //  
                     first_event_reg <= 1'b1;                     
                 end
                 else begin
                     //   
                     SlCounter <= SlCounter - 1;
                 end
             end
             else begin
                 //  
                 SlCounter <= Delay;
             end
         end
         else begin
         //    
             if((first_event_reg == 1'b1) && (sync_state == 1'b1)) begin
                 last_event_reg <= 1'b1;
             end
         end
     end //   

end //

endmodule 